diff --git a/gcc/analyzer/region-model2.h b/gcc/analyzer/region-model2.h
index 9127c5ab9f3..a9bf778e2d3 100644
--- a/gcc/analyzer/region-model2.h
+++ b/gcc/analyzer/region-model2.h
@@ -157,14 +157,18 @@ public:
   virtual void dump_to_pp (pretty_printer *pp, bool simple) const = 0;
   void dump (bool simple=true) const;
 
-  virtual region_svalue2 *dyn_cast_region_svalue2 () { return NULL; }
-  virtual constant_svalue2 *dyn_cast_constant_svalue2 () { return NULL; }
-  virtual const constant_svalue2 *dyn_cast_constant_svalue2 () const
-  { return NULL; }
-  virtual poisoned_svalue2 *dyn_cast_poisoned_svalue2 () { return NULL; }
-  virtual unknown_svalue2 *dyn_cast_unknown_svalue2 () { return NULL; }
-  virtual setjmp_svalue2 *dyn_cast_setjmp_svalue2 () { return NULL; }
-  virtual initial_svalue2 *dyn_cast_initial_svalue2 () { return NULL; }
+  virtual const region_svalue2 *
+  dyn_cast_region_svalue2 () const { return NULL; }
+  virtual const constant_svalue2 *
+  dyn_cast_constant_svalue2 () const { return NULL; }
+  virtual const poisoned_svalue2 *
+  dyn_cast_poisoned_svalue2 () const { return NULL; }
+  virtual const unknown_svalue2 *
+  dyn_cast_unknown_svalue2 () const { return NULL; }
+  virtual const setjmp_svalue2 *
+  dyn_cast_setjmp_svalue2 () const { return NULL; }
+  virtual const initial_svalue2 *
+  dyn_cast_initial_svalue2 () const { return NULL; }
 
   tree maybe_get_constant () const;
 
@@ -189,13 +193,13 @@ public:
 class region_svalue2 : public svalue2
 {
 public:
-  region_svalue2 (tree type, region2 *reg) : svalue2 (type), m_reg (reg)
+  region_svalue2 (tree type, const region2 *reg) : svalue2 (type), m_reg (reg)
   {
     gcc_assert (m_reg != NULL);
   }
 
 #if 0
-  svalue2 *clone () const FINAL OVERRIDE
+  const svalue2 *clone () const FINAL OVERRIDE
   { return new region_svalue2 (get_type (), m_reg); }
 #endif
 
@@ -209,9 +213,10 @@ public:
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  region_svalue2 *dyn_cast_region_svalue2 () FINAL OVERRIDE { return this; }
+  const region_svalue2 *
+  dyn_cast_region_svalue2 () const FINAL OVERRIDE { return this; }
 
-  region2 * get_pointee () const { return m_reg; }
+  const region2 * get_pointee () const { return m_reg; }
 
 #if 0
   static void merge_values (const region_svalue2 &region_sval_a,
@@ -221,9 +226,9 @@ public:
 			    model_merger *merger);
 #endif
 
-  static tristate eval_condition (region_svalue2 *lhs_ptr,
+  static tristate eval_condition (const region_svalue2 *lhs_ptr,
 				  enum tree_code op,
-				  region_svalue2 *rhs_ptr);
+				  const region_svalue2 *rhs_ptr);
 
 #if 0
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
@@ -235,7 +240,7 @@ public:
     FINAL OVERRIDE;
 #endif
 
-  region2 *m_reg;
+  const region2 *m_reg;
 };
 
 } // namespace ana
@@ -243,7 +248,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <region_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const region_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_REGION;
 }
@@ -263,7 +268,7 @@ public:
   }
 
 #if 0
-  svalue2 *clone () const FINAL OVERRIDE
+  const svalue2 *clone () const FINAL OVERRIDE
   { return new constant_svalue2 (m_cst_expr); }
 #endif
 
@@ -274,9 +279,8 @@ public:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
 #endif
 
-  constant_svalue2 *dyn_cast_constant_svalue2 () FINAL OVERRIDE { return this; }
-  const constant_svalue2 *dyn_cast_constant_svalue2 () const FINAL OVERRIDE
-  { return this; }
+  const constant_svalue2 *
+  dyn_cast_constant_svalue2 () const FINAL OVERRIDE { return this; }
 
   tree get_constant () const { return m_cst_expr; }
 
@@ -287,9 +291,9 @@ public:
 			    model_merger *merger);
 #endif
 
-  static tristate eval_condition (constant_svalue2 *lhs,
+  static tristate eval_condition (const constant_svalue2 *lhs,
 				  enum tree_code op,
-				  constant_svalue2 *rhs);
+				  const constant_svalue2 *rhs);
 
  private:
 #if 0
@@ -306,7 +310,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <constant_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const constant_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_CONSTANT;
 }
@@ -336,7 +340,8 @@ public:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
 #endif
 
-  unknown_svalue2 *dyn_cast_unknown_svalue2 () FINAL OVERRIDE { return this; }
+  const unknown_svalue2 *
+  dyn_cast_unknown_svalue2 () const FINAL OVERRIDE { return this; }
 
  private:
 #if 0
@@ -385,7 +390,8 @@ public:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
 #endif
 
-  poisoned_svalue2 *dyn_cast_poisoned_svalue2 () FINAL OVERRIDE { return this; }
+  const poisoned_svalue2 *
+  dyn_cast_poisoned_svalue2 () const FINAL OVERRIDE { return this; }
 
   enum poison_kind get_poison_kind () const { return m_kind; }
 
@@ -404,7 +410,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <poisoned_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const poisoned_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_POISONED;
 }
@@ -457,7 +463,8 @@ public:
   void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
 #endif
 
-  setjmp_svalue2 *dyn_cast_setjmp_svalue2 () FINAL OVERRIDE { return this; }
+  const setjmp_svalue2 *
+  dyn_cast_setjmp_svalue2 () const FINAL OVERRIDE { return this; }
 
   int get_enode_index () const;
 
@@ -495,7 +502,8 @@ public:
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  initial_svalue2 *dyn_cast_initial_svalue2 () FINAL OVERRIDE { return this; }
+  const initial_svalue2 *
+  dyn_cast_initial_svalue2 () const FINAL OVERRIDE { return this; }
 
   const region2 * get_region () const { return m_reg; }
 
@@ -525,7 +533,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <initial_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const initial_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_INITIAL;
 }
@@ -561,7 +569,7 @@ public:
   /* A support class for uniquifying instances of unaryop_svalue2.  */
   struct key_t
   {
-    key_t (tree type, enum tree_code op, svalue2 *arg)
+    key_t (tree type, enum tree_code op, const svalue2 *arg)
     : m_type (type), m_op (op), m_arg (arg)
     {}
 
@@ -584,10 +592,10 @@ public:
 
     tree m_type;
     enum tree_code m_op;
-    svalue2 *m_arg;
+    const svalue2 *m_arg;
   };
 
-  unaryop_svalue2 (tree type, enum tree_code op, svalue2 *arg)
+  unaryop_svalue2 (tree type, enum tree_code op, const svalue2 *arg)
   : svalue2 (type), m_op (op), m_arg (arg)
   {
   }
@@ -603,7 +611,8 @@ public:
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
 #if 0
-  unaryop_svalue2 *dyn_cast_unaryop_svalue2 () FINAL OVERRIDE { return this; }
+  const unaryop_svalue2 *
+  dyn_cast_unaryop_svalue2 () const FINAL OVERRIDE { return this; }
 #endif
 
 #if 0
@@ -617,7 +626,7 @@ public:
 #endif
 
   enum tree_code m_op;
-  svalue2 *m_arg;
+  const svalue2 *m_arg;
 };
 
 } // namespace ana
@@ -625,7 +634,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <unaryop_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const unaryop_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_UNARYOP;
 }
@@ -647,7 +656,8 @@ public:
   /* A support class for uniquifying instances of binop_svalue2.  */
   struct key_t
   {
-    key_t (tree type, enum tree_code op, svalue2 *arg0, svalue2 *arg1)
+    key_t (tree type, enum tree_code op,
+	   const svalue2 *arg0, const svalue2 *arg1)
     : m_type (type), m_op (op), m_arg0 (arg0), m_arg1 (arg1)
     {}
 
@@ -671,11 +681,12 @@ public:
 
     tree m_type;
     enum tree_code m_op;
-    svalue2 *m_arg0;
-    svalue2 *m_arg1;
+    const svalue2 *m_arg0;
+    const svalue2 *m_arg1;
   };
 
-  binop_svalue2 (tree type, enum tree_code op, svalue2 *arg0, svalue2 *arg1)
+  binop_svalue2 (tree type, enum tree_code op,
+		 const svalue2 *arg0, const svalue2 *arg1)
   : svalue2 (type), m_op (op), m_arg0 (arg0), m_arg1 (arg1)
   {
   }
@@ -683,8 +694,8 @@ public:
   enum kind get_kind () const FINAL OVERRIDE { return SK_BINOP; }
 
   enum tree_code get_op () const { return m_op; }
-  svalue2 *get_arg0 () const { return m_arg0; }
-  svalue2 *get_arg1 () const { return m_arg1; }
+  const svalue2 *get_arg0 () const { return m_arg0; }
+  const svalue2 *get_arg1 () const { return m_arg1; }
 
 #if 0
   void dump_dot_to_pp (const region_model2 &model,
@@ -695,7 +706,8 @@ public:
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
 #if 0
-  binop_svalue2 *dyn_cast_binop_svalue2 () FINAL OVERRIDE { return this; }
+  const binop_svalue2 *
+  dyn_cast_binop_svalue2 () const FINAL OVERRIDE { return this; }
 #endif
 
 #if 0
@@ -709,8 +721,8 @@ public:
 #endif
 
   enum tree_code m_op;
-  svalue2 *m_arg0;
-  svalue2 *m_arg1;
+  const svalue2 *m_arg0;
+  const svalue2 *m_arg1;
 };
 
 } // namespace ana
@@ -718,7 +730,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <binop_svalue2 *>::test (svalue2 *sval)
+is_a_helper <const binop_svalue2 *>::test (const svalue2 *sval)
 {
   return sval->get_kind () == svalue2::SK_BINOP;
 }
@@ -812,16 +824,22 @@ public:
   static int cmp_ids (const region2 *reg1, const region2 *reg2);
 
   virtual enum kind get_kind () const = 0;
-  virtual function_region2 *dyn_cast_function_region2 () { return NULL; }
-  virtual symbolic_region2 *dyn_cast_symbolic_region2 () { return NULL; }
-  virtual const symbolic_region2 *dyn_cast_symbolic_region2 () const { return NULL; }
-  virtual const decl_region2 *dyn_cast_decl_region2 () const { return NULL; }
-  virtual field_region2 *dyn_cast_field_region2 () { return NULL; }
-  virtual element_region2 *dyn_cast_element_region2 () { return NULL; }
-  virtual offset_region2 *dyn_cast_offset_region2 () { return NULL; }
-  virtual string_region2 *dyn_cast_string_region2 () { return NULL; }
-
-  region2 *get_parent_region () const { return m_parent; }
+  virtual const function_region2 *
+  dyn_cast_function_region2 () const { return NULL; }
+  virtual const symbolic_region2 *
+  dyn_cast_symbolic_region2 () const { return NULL; }
+  virtual const decl_region2 *
+  dyn_cast_decl_region2 () const { return NULL; }
+  virtual const field_region2 *
+  dyn_cast_field_region2 () const { return NULL; }
+  virtual const element_region2 *
+  dyn_cast_element_region2 () const { return NULL; }
+  virtual const offset_region2 *
+  dyn_cast_offset_region2 () const { return NULL; }
+  virtual const string_region2 *
+  dyn_cast_string_region2 () const { return NULL; }
+
+  const region2 *get_parent_region () const { return m_parent; }
   const region2 *get_base_region () const;
 
 #if 0
@@ -874,12 +892,12 @@ public:
 
   static int cmp_ptrs (const void *, const void *);
 
-  region_offset get_offset ();
+  region_offset get_offset () const;
 
   virtual path_var get_representative_path_var () const;
 
  protected:
-  region2 (unsigned id, region2 *parent, tree type);
+  region2 (unsigned id, const region2 *parent, tree type);
 
   virtual void add_to_hash (inchash::hash &hstate) const;
 #if 0
@@ -896,10 +914,10 @@ public:
   region_offset calc_offset () const;
 
   unsigned m_id; // purely for deterministic sorting at this stage, for dumps
-  region2 *m_parent;
+  const region2 *m_parent;
   tree m_type;
 
-  region_offset *m_cached_offset;
+  mutable region_offset *m_cached_offset;
 };
 
 } // namespace ana
@@ -907,7 +925,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <region2 *>::test (region2 *)
+is_a_helper <const region2 *>::test (const region2 *)
 {
   return true;
 }
@@ -920,7 +938,7 @@ namespace ana {
 class space_region2 : public region2
 {
 protected:
-  space_region2 (unsigned id, region2 *parent)
+  space_region2 (unsigned id, const region2 *parent)
   : region2 (id, parent, NULL_TREE)
   {}
 };
@@ -940,8 +958,8 @@ protected:
 class frame_region2 : public space_region2
 {
 public:
-  frame_region2 (unsigned id, region2 *parent,
-		 frame_region2 *calling_frame,
+  frame_region2 (unsigned id, const region2 *parent,
+		 const frame_region2 *calling_frame,
 		 function *fun, int index)
   : space_region2 (id, parent), m_calling_frame (calling_frame),
     m_fun (fun), m_index (index)
@@ -959,19 +977,19 @@ public:
 #endif
 
   /* Accessors.  */
-  frame_region2 *get_calling_frame () const { return m_calling_frame; }
+  const frame_region2 *get_calling_frame () const { return m_calling_frame; }
   function *get_function () const { return m_fun; }
   int get_index () const { return m_index; }
   int get_stack_depth () const { return m_index + 1; }
 
   bool compare_fields (const frame_region2 &other) const;
 
-  region2 *get_region_for_local (region_model2_manager *mgr,
-				 tree expr,
-				 region_model2_context *ctxt);
+  const region2 *get_region_for_local (region_model2_manager *mgr,
+				       tree expr,
+				       region_model2_context *ctxt) const;
 
  private:
-  frame_region2 *m_calling_frame;
+  const frame_region2 *m_calling_frame;
   function *m_fun;
   int m_index;
   typedef hash_map<tree, region2 *> map_t;
@@ -985,7 +1003,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <frame_region2 *>::test (region2 *reg)
+is_a_helper <const frame_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_FRAME;
 }
@@ -997,7 +1015,7 @@ namespace ana {
 class globals_region2 : public space_region2
 {
  public:
-  globals_region2 (unsigned id, region2 *parent)
+  globals_region2 (unsigned id, const region2 *parent)
   : space_region2 (id, parent)
   {}
 
@@ -1016,7 +1034,7 @@ class globals_region2 : public space_region2
 template <>
 template <>
 inline bool
-is_a_helper <globals_region2 *>::test (region2 *reg)
+is_a_helper <const globals_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_GLOBALS;
 }
@@ -1029,7 +1047,7 @@ namespace ana {
 class code_region2 : public space_region2
 {
 public:
-  code_region2 (unsigned id, region2 *parent)
+  code_region2 (unsigned id, const region2 *parent)
   : space_region2 (id, parent)
   {}
 
@@ -1037,8 +1055,8 @@ public:
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
   enum kind get_kind () const FINAL OVERRIDE { return RK_CODE; }
 
-  region2 *get_element (region_model2 *model,
-			svalue2 *index,
+  const region2 *get_element (region_model2 *model,
+			const svalue2 *index,
 			region_model2_context *ctxt);
 
   bool compare_fields (const code_region2 &other) const;
@@ -1049,7 +1067,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <code_region2 *>::test (region2 *reg)
+is_a_helper <const code_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_CODE;
 }
@@ -1063,7 +1081,7 @@ namespace ana {
 class function_region2 : public region2
 {
 public:
-  function_region2 (unsigned id, code_region2 *parent, tree fndecl)
+  function_region2 (unsigned id, const code_region2 *parent, tree fndecl)
   : region2 (id, parent, TREE_TYPE (fndecl)), m_fndecl (fndecl)
   {
     gcc_assert (FUNC_OR_METHOD_TYPE_P (TREE_TYPE (fndecl)));
@@ -1072,12 +1090,13 @@ public:
   /* region2 vfuncs.  */
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
   enum kind get_kind () const FINAL OVERRIDE { return RK_FUNCTION; }
-  function_region2 *dyn_cast_function_region2 () { return this; }
+  const function_region2 *
+  dyn_cast_function_region2 () const FINAL OVERRIDE{ return this; }
 
   tree get_fndecl () const { return m_fndecl; }
 
   region2 *get_element (region_model2 *model,
-			svalue2 *index_sid,
+			const svalue2 *index_sid,
 			region_model2_context *ctxt);
 
   bool compare_fields (const function_region2 &other) const;
@@ -1091,7 +1110,7 @@ private:
 template <>
 template <>
 inline bool
-is_a_helper <function_region2 *>::test (region2 *reg)
+is_a_helper <const function_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_FUNCTION;
 }
@@ -1105,7 +1124,7 @@ namespace ana {
 class label_region2 : public region2
 {
 public:
-  label_region2 (unsigned id, function_region2 *parent, tree label)
+  label_region2 (unsigned id, const function_region2 *parent, tree label)
   : region2 (id, parent, NULL_TREE), m_label (label)
   {
     gcc_assert (TREE_CODE (label) == LABEL_DECL);
@@ -1126,7 +1145,7 @@ private:
 template <>
 template <>
 inline bool
-is_a_helper <label_region2 *>::test (region2 *reg)
+is_a_helper <const label_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_LABEL;
 }
@@ -1161,7 +1180,7 @@ public:
   static bool can_merge_p (const stack_region2 *stack_region2_a,
 			   const stack_region2 *stack_region2_b,
 			   model_merger *merger);
-  svalue2 *get_value_by_name (tree identifier,
+  const svalue2 *get_value_by_name (tree identifier,
 			      const region_model2 &model) const;
 #endif
 
@@ -1186,7 +1205,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <stack_region2 *>::test (region2 *reg)
+is_a_helper <const stack_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_STACK;
 }
@@ -1222,7 +1241,7 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <heap_region2 *>::test (region2 *reg)
+is_a_helper <const heap_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_HEAP;
 }
@@ -1277,7 +1296,7 @@ public:
 			   model_merger *merger);
 #endif
 
-  svalue2 *get_value_by_name (tree identifier,
+  const svalue2 *get_value_by_name (tree identifier,
 			      const region_model2 &model) const;
 
 #if 0
@@ -1305,7 +1324,7 @@ private:
 template <>
 template <>
 inline bool
-is_a_helper <root_region2 *>::test (region2 *reg)
+is_a_helper <const root_region2 *>::test (const region2 *reg)
 {
   return reg->get_kind () == region2::RK_ROOT;
 }
@@ -1318,15 +1337,13 @@ namespace ana {
 class symbolic_region2 : public region2
 {
 public:
-  symbolic_region2 (unsigned id, region2 *parent, svalue2 *sval_ptr)
+  symbolic_region2 (unsigned id, region2 *parent, const svalue2 *sval_ptr)
   : region2 (id, parent, TREE_TYPE (sval_ptr->get_type ())),
     m_sval_ptr (sval_ptr)
   {}
 
-  const symbolic_region2 *dyn_cast_symbolic_region2 () const FINAL OVERRIDE
-  { return this; }
-  symbolic_region2 *dyn_cast_symbolic_region2 () FINAL OVERRIDE
-  { return this; }
+  const symbolic_region2 *
+  dyn_cast_symbolic_region2 () const FINAL OVERRIDE { return this; }
 
   bool compare_fields (const symbolic_region2 &other) const;
 
@@ -1334,7 +1351,7 @@ public:
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  svalue2 *get_pointer () const { return m_sval_ptr; }
+  const svalue2 *get_pointer () const { return m_sval_ptr; }
 
 #if 0
   void print_fields (const region_model2 &model,
@@ -1342,7 +1359,7 @@ public:
 #endif
 
 private:
-  svalue2 *m_sval_ptr;
+  const svalue2 *m_sval_ptr;
 };
 
 /* FIXME.  */
@@ -1350,7 +1367,7 @@ private:
 class decl_region2 : public region2
 {
 public:
-  decl_region2 (unsigned id, region2 *parent, tree decl)
+  decl_region2 (unsigned id, const region2 *parent, tree decl)
   : region2 (id, parent, TREE_TYPE (decl)), m_decl (decl)
   {}
 
@@ -1361,8 +1378,8 @@ public:
   bool compare_fields (const decl_region2 &other) const;
 
   enum region2::kind get_kind () const FINAL OVERRIDE { return RK_DECL; }
-  const decl_region2 *dyn_cast_decl_region2 () const FINAL OVERRIDE
-  { return this; }
+  const decl_region2 *
+  dyn_cast_decl_region2 () const FINAL OVERRIDE { return this; }
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
   path_var get_representative_path_var () const FINAL OVERRIDE;
@@ -1381,7 +1398,7 @@ private:
 class field_region2 : public region2
 {
 public:
-  field_region2 (unsigned id, region2 *parent, tree field)
+  field_region2 (unsigned id, const region2 *parent, tree field)
   : region2 (id, parent, TREE_TYPE (field)), m_field (field)
   {}
 
@@ -1390,7 +1407,8 @@ public:
   enum region2::kind get_kind () const FINAL OVERRIDE { return RK_FIELD; }
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
-  field_region2 *dyn_cast_field_region2 () FINAL OVERRIDE { return this; }
+  const field_region2 *
+  dyn_cast_field_region2 () const FINAL OVERRIDE { return this; }
 
   tree get_field () const { return m_field; }
 
@@ -1406,25 +1424,26 @@ private:
 class element_region2 : public region2
 {
 public:
-  element_region2 (unsigned id, region2 *parent, tree element_type,
-		   svalue2 *index)
+  element_region2 (unsigned id, const region2 *parent, tree element_type,
+		   const svalue2 *index)
   : region2 (id, parent, element_type), m_index (index)
   {}
 
   bool compare_fields (const element_region2 &other) const;
 
   enum region2::kind get_kind () const FINAL OVERRIDE { return RK_ELEMENT; }
-  element_region2 *dyn_cast_element_region2 () FINAL OVERRIDE { return this; }
+  const element_region2 *
+  dyn_cast_element_region2 () const FINAL OVERRIDE { return this; }
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  svalue2 *get_index () const { return m_index; }
+  const svalue2 *get_index () const { return m_index; }
 
 protected:
   void add_to_hash (inchash::hash &hstate) const OVERRIDE;
 
 private:
-  svalue2 *m_index;
+  const svalue2 *m_index;
 };
 
 /* A byte-offset within another region, for handling pointer arithmetic
@@ -1433,24 +1452,26 @@ private:
 class offset_region2 : public region2
 {
 public:
-  offset_region2 (unsigned id, region2 *parent, tree type, svalue2 *byte_offset)
+  offset_region2 (unsigned id, const region2 *parent, tree type,
+		  const svalue2 *byte_offset)
   : region2 (id, parent, type), m_byte_offset (byte_offset)
   {}
 
   bool compare_fields (const offset_region2 &other) const;
 
   enum region2::kind get_kind () const FINAL OVERRIDE { return RK_OFFSET; }
-  offset_region2 *dyn_cast_offset_region2 () FINAL OVERRIDE { return this; }
+  const offset_region2 *
+  dyn_cast_offset_region2 () const FINAL OVERRIDE { return this; }
 
   void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  svalue2 *get_byte_offset () const { return m_byte_offset; }
+  const svalue2 *get_byte_offset () const { return m_byte_offset; }
 
 protected:
   void add_to_hash (inchash::hash &hstate) const OVERRIDE;
 
 private:
-  svalue2 *m_byte_offset;
+  const svalue2 *m_byte_offset;
 };
 
 /* An untyped region dynamically allocated on the heap via "malloc"
@@ -1460,7 +1481,7 @@ private:
 class heap_allocated_region2 : public region2
 {
 public:
-  heap_allocated_region2 (unsigned id, region2 *parent)
+  heap_allocated_region2 (unsigned id, const region2 *parent)
   : region2 (id, parent, NULL_TREE)
   {}
 
@@ -1482,7 +1503,7 @@ protected:
 class alloca_region2 : public region2
 {
 public:
-  alloca_region2 (unsigned id, frame_region2 *parent)
+  alloca_region2 (unsigned id, const frame_region2 *parent)
   : region2 (id, parent, NULL_TREE)
   {}
 
@@ -1504,11 +1525,12 @@ protected:
 class string_region2 : public region2
 {
 public:
-  string_region2 (unsigned id, region2 *parent, tree string_cst)
+  string_region2 (unsigned id, const region2 *parent, tree string_cst)
   : region2 (id, parent, TREE_TYPE (string_cst)), m_string_cst (string_cst)
   {}
 
-  string_region2 *dyn_cast_string_region2 () FINAL OVERRIDE { return this; }
+  const string_region2 *
+  dyn_cast_string_region2 () const FINAL OVERRIDE { return this; }
 
 #if 0
   bool compare_fields (const element_region2 &other) const;
@@ -1532,7 +1554,7 @@ private:
 class unknown_region2 : public region2
 {
 public:
-  unknown_region2 (unsigned id, region2 *parent, tree type)
+  unknown_region2 (unsigned id, const region2 *parent, tree type)
   : region2 (id, parent, type)
   {}
 
@@ -1550,7 +1572,9 @@ protected:
 };
 
 /* A class responsible for owning and consolidating region2 and svalue2
-   instances.    */
+   instances.
+   region2 and svalue2 instances are immutable as far as clients are
+   concerned, so they are provided as "const" ptrs.  */
 
 class region_model2_manager
 {
@@ -1559,39 +1583,41 @@ public:
   ~region_model2_manager ();
 
   /* svalue2 consolidation.  */
-  svalue2 *get_or_create_constant_svalue2 (tree cst_expr);
-  svalue2 *get_or_create_initial_value (const region2 *reg);
-  svalue2 *get_ptr_svalue2 (tree ptr_type, region2 *pointee);
-  svalue2 *get_or_create_unaryop (tree type, enum tree_code op, svalue2 *arg);
-  svalue2 *get_or_create_binop (tree type,
-				enum tree_code op,
-				svalue2 *arg0, svalue2 *arg1);
+  const svalue2 *get_or_create_constant_svalue2 (tree cst_expr);
+  const svalue2 *get_or_create_initial_value (const region2 *reg);
+  const svalue2 *get_ptr_svalue2 (tree ptr_type, const region2 *pointee);
+  const svalue2 *get_or_create_unaryop (tree type, enum tree_code op,
+					const svalue2 *arg);
+  const svalue2 *get_or_create_binop (tree type,
+				      enum tree_code op,
+				      const svalue2 *arg0, const svalue2 *arg1);
 
   /* region2 consolidation.  */
-  function_region2 *get_region_for_fndecl (tree fndecl,
-					   region_model2_context *ctxt);
-  label_region2 *get_region_for_label (tree label,
-				       region_model2_context *ctxt);
-  decl_region2 *get_region_for_global (tree expr,
-				       region_model2_context *ctxt);
-  region2 *get_field_region (region2 *parent, tree field,
-			     region_model2_context *ctxt);
-  region2 *get_element_region (region2 *parent,
-			       tree element_type,
-			       svalue2 *index,
-			       region_model2_context *ctxt);
-  region2 *get_offset_region (region2 *parent,
-			      tree type,
-			      svalue2 *byte_offset,
-			      region_model2_context *ctxt);
-  frame_region2 *get_frame_region (frame_region2 *calling_frame,
-				   function *fun);
-  region2 *get_symbolic_region (svalue2 *sval);
-  string_region2 *get_region_for_string (tree string_cst);
+  const function_region2 *get_region_for_fndecl (tree fndecl,
+						 region_model2_context *ctxt);
+  const label_region2 *get_region_for_label (tree label,
+					     region_model2_context *ctxt);
+  const decl_region2 *get_region_for_global (tree expr,
+					     region_model2_context *ctxt);
+  const region2 *get_field_region (const region2 *parent, tree field,
+				   region_model2_context *ctxt);
+  const region2 *get_element_region (const region2 *parent,
+				     tree element_type,
+				     const svalue2 *index,
+				     region_model2_context *ctxt);
+  const region2 *get_offset_region (const region2 *parent,
+				    tree type,
+				    const svalue2 *byte_offset,
+				    region_model2_context *ctxt);
+  const frame_region2 *get_frame_region (const frame_region2 *calling_frame,
+					 function *fun);
+  const region2 *get_symbolic_region (const svalue2 *sval);
+  const string_region2 *get_region_for_string (tree string_cst);
 
-  region2 *get_region2_for_unexpected_tree_code (region_model2_context *ctxt,
-						 tree t,
-						 const dump_location_t &loc);
+  const region2 *
+  get_region2_for_unexpected_tree_code (region_model2_context *ctxt,
+					tree t,
+					const dump_location_t &loc);
 
   unsigned alloc_region_id () { return m_next_region_id++; }
 
@@ -1600,14 +1626,14 @@ public:
   /* Dynamically-allocated region2 instances.
      FIXME: for now, the number of these within the analysis can grow
      arbitrarily.  They are still owned by the manager.  */
-  region2 *create_region_for_heap_alloc ();
-  region2 *create_region_for_alloca (frame_region2 *frame);
+  const region2 *create_region_for_heap_alloc ();
+  const region2 *create_region_for_alloca (const frame_region2 *frame);
 
 private:
-  svalue2 *maybe_fold_unaryop (tree type, enum tree_code op,
-			       svalue2 *arg);
-  svalue2 *maybe_fold_binop (tree type, enum tree_code op,
-			     svalue2 *arg0, svalue2 *arg1);
+  const svalue2 *maybe_fold_unaryop (tree type, enum tree_code op,
+				     const svalue2 *arg);
+  const svalue2 *maybe_fold_binop (tree type, enum tree_code op,
+				   const svalue2 *arg0, const svalue2 *arg1);
 
   unsigned m_next_region_id;
   root_region2 m_root_region;
@@ -1755,25 +1781,25 @@ class region_model2
 
   region2_id get_stack_region2_id () const;
 #endif
-  region2 *push_frame (function *fun, vec<svalue2 *> *arg_sids,
-		       region_model2_context *ctxt);
-  frame_region2 *get_current_frame () const { return m_current_frame; }
+  const region2 *push_frame (function *fun, vec<const svalue2 *> *arg_sids,
+			     region_model2_context *ctxt);
+  const frame_region2 *get_current_frame () const { return m_current_frame; }
   function * get_current_function () const;
-  void pop_frame (region2 *result_dst,
+  void pop_frame (const region2 *result_dst,
 		  bool purge, purge_stats2 *stats,
 		  region_model2_context *ctxt);
   int get_stack_depth () const;
-  frame_region2 *get_frame_at_index (int index) const;
+  const frame_region2 *get_frame_at_index (int index) const;
 
 #if 0
   region2_id get_globals_region2_id () const;
-  void replace_svalue2 (svalue2_id sid, svalue2 *new_sval);
+  void replace_svalue2 (svalue2_id sid, const svalue2 *new_sval);
 #endif
 
-  region2 *get_lvalue (path_var pv, region_model2_context *ctxt);
-  region2 *get_lvalue (tree expr, region_model2_context *ctxt);
-  svalue2 *get_rvalue (path_var pv, region_model2_context *ctxt);
-  svalue2 *get_rvalue (tree expr, region_model2_context *ctxt);
+  const region2 *get_lvalue (path_var pv, region_model2_context *ctxt);
+  const region2 *get_lvalue (tree expr, region_model2_context *ctxt);
+  const svalue2 *get_rvalue (path_var pv, region_model2_context *ctxt);
+  const svalue2 *get_rvalue (tree expr, region_model2_context *ctxt);
 
 #if 0
   svalue2_id get_or_create_ptr_svalue2 (tree ptr_type, region2_id id);
@@ -1785,26 +1811,27 @@ class region_model2
 			      region_model2_context *ctxt);
 #endif
 
-  region2 *deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt);
+  const region2 *deref_rvalue (const svalue2 *ptr_sval,
+			       region_model2_context *ctxt);
 #if 0
-  region2 *deref_rvalue (tree ptr, region_model2_context *ctxt);
+  const region2 *deref_rvalue (tree ptr, region_model2_context *ctxt);
 #endif
 
-  void set_value (region2 *lhs_reg, svalue2 *rhs_sval,
+  void set_value (const region2 *lhs_reg, const svalue2 *rhs_sval,
 		  region_model2_context *ctxt);
   void set_value (tree lhs, tree rhs, region_model2_context *ctxt);
-  void clobber_region (region2 *reg);
+  void clobber_region (const region2 *reg);
   void purge_region (const region2 *reg);
-  svalue2 *set_to_new_unknown_value (region2 *dst_reg, tree type,
+  const svalue2 *set_to_new_unknown_value (const region2 *dst_reg, tree type,
 				     region_model2_context *ctxt);
-  void copy_region (region2 *dst_reg, region2 *src_reg,
+  void copy_region (const region2 *dst_reg, const region2 *src_reg,
 		    region_model2_context *ctxt);
-  tristate eval_condition (svalue2 *lhs,
+  tristate eval_condition (const svalue2 *lhs,
 			   enum tree_code op,
-			   svalue2 *rhs) const;
-  tristate eval_condition_without_cm (svalue2 *lhs,
+			   const svalue2 *rhs) const;
+  tristate eval_condition_without_cm (const svalue2 *lhs,
 				      enum tree_code op,
-				      svalue2 *rhs) const;
+				      const svalue2 *rhs) const;
   tristate eval_condition (tree lhs,
 			   enum tree_code op,
 			   tree rhs,
